/*
 * TLC5940.c
 *
 *  Created on: 2021830
 *      Author: admin
 */

#include "TLC5940.h"

unsigned char PWMtable1[24] = {	0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
								0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
								0x55, 0x55, 0x55, 0x55};

unsigned char PWMtable2[24] = {	0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa,
								0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa,
								0xaa, 0xaa, 0xaa, 0xaa};

unsigned char PWMtable[24] = {	0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc,
								0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc,
								0xcc, 0xcc, 0xcc, 0xcc};
void EnableAllPWM() {
	TLC5940_BLANK(0);
}

void DisableAllPWM() {
	TLC5940_BLANK(1);
}

void Refresh(){
	WriteXBit( &PWMtable[0], 24 );
}

void WriteXBit(unsigned char* pWriteData, unsigned char bitNumber) {
    unsigned char i;
    unsigned char index = 0;        	// ±
    unsigned char count = 0;        	// λ
    unsigned char Temp = 0;

    TLC5940_XLAT(0);
    TLC5940_DCPRGK(1);
    for (i = 0; i < bitNumber; i++) 	// ѭдλ
    {
    	TLC5940_SCLK(0);
        Temp = (pWriteData[index] & 0x80);
        if (Temp == 0x80)           	// дλΪ1Ϊ0
        	TLC5940_SIN(1);             // Ϊ1ʱ1Ŀ
        else
        	TLC5940_SIN(0);             // Ϊ0ʱ0Ŀ
    	TLC5940_SCLK(1);
        pWriteData[index] <<= 1;    	// λ
        count++;                    	// 8λ1
        if (count >= 8) {
            index++;                	// 8λдһֽڣ±1
            count = 0;              	// 8λλ0¿ʼ
        }
    }
    TLC5940_XLAT(1);
}
